var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  applyUserBabelConfig: () => import_utils.applyUserBabelConfig,
  getBabelChain: () => getBabelChain,
  getBabelConfig: () => getBabelConfig
});
module.exports = __toCommonJS(src_exports);
var import_babel_preset_base = require("@modern-js/babel-preset-base");
var import_plugins = require("./plugins");
__reExport(src_exports, require("@modern-js/babel-preset-base"), module.exports);
__reExport(src_exports, require("./types"), module.exports);
var import_utils = require("@modern-js/utils");
const getBabelConfig = (libPresetOption, syntaxOption) => getBabelChain(libPresetOption, syntaxOption).toJSON();
const getBabelChain = (libPresetOption, syntaxOption) => {
  const {
    appDirectory,
    jsxTransformRuntime,
    enableReactPreset,
    enableTypescriptPreset,
    lodashOptions,
    styledComponentsOptions
  } = libPresetOption;
  const { syntax, type } = syntaxOption;
  const chain = (0, import_babel_preset_base.createBabelChain)();
  const baseChain = (0, import_babel_preset_base.getBaseBabelChain)({
    appDirectory,
    type,
    syntax,
    presets: {
      envOptions: true,
      reactOptions: enableReactPreset,
      typescriptOptions: enableTypescriptPreset ? { allowDeclareFields: true, allExtensions: true } : false
    },
    plugins: {
      transformRuntime: {
        corejs: false,
        // 关闭 corejs
        // for es5 code need helper functions
        helpers: syntaxOption.syntax === "es5"
      },
      lodashOptions,
      styledComponentsOptions
    },
    jsxTransformRuntime
  });
  const plugins = (0, import_plugins.getPlugins)(libPresetOption);
  return chain.merge(baseChain).merge(plugins);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  applyUserBabelConfig,
  getBabelChain,
  getBabelConfig
});
